import _mergeJSXProps from 'babel-helper-vue-jsx-merge-props';
var CarouselItem = {
    data: function data() {
        return {
            offset: 0
        };
    },
    beforeCreate: function beforeCreate() {
        this.$parent.swipes.push(this);
    },
    destroyed: function destroyed() {
        this.$parent.swipes.splice(this.$parent.swipes.indexOf(this), 1);
    },
    render: function render() {
        var h = arguments[0];
        var _$parent = this.$parent,
            vertical = _$parent.vertical,
            computedWidth = _$parent.computedWidth,
            computedHeight = _$parent.computedHeight;


        var style = {
            width: computedWidth + 'px',
            height: vertical ? computedHeight + 'px' : '100%',
            transform: 'translate' + (vertical ? 'Y' : 'X') + '(' + this.offset + 'px)'
        };

        return h(
            'div',
            _mergeJSXProps([{
                'class': 'sn-carousel-item',
                style: style
            }, { on: this.$listeners }]),
            [this.$slots['default']]
        );
    }
};

export default CarouselItem;