'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

require('./index.less');

var Collapse = {
    name: "Collapse",
    props: {
        accordion: Boolean,
        value: [String, Number, Array]
    },
    methods: {
        'switch': function _switch(name, expanded) {
            if (!this.accordion) {
                name = expanded ? this.value.concat(name) : this.value.filter(function (activeName) {
                    return activeName !== name;
                });
            }
            this.$emit('change', name);
            this.$emit('input', name);
        }
    },
    render: function render() {
        var h = arguments[0];
        var $slots = this.$slots;

        return h(
            'div',
            { 'class': 'sn-collapse' },
            [$slots['default']]
        );
    }
};

exports['default'] = Collapse;
module.exports = exports.default;